// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 24 mayo 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// EDEP EmpujeDobleExhibicionPublica
// El archivo dibuja un aparato de ejercicios de tipo empuje doble, similar a los que
// se encuentran actualmente en algunos parques publicos de Costa Rica.
//
// La macro principal tiene dos parametros. 
// #macro EDEP_EmpujeDoble( FraccionDerecho, FraccionIzquierdo )  
//      FraccionDerecho         : Fraccion propia de empuje para las barras
//              en el hemisferio X-.
//      FraccionIzquierdo       : Fraccion propia de empuje para las barras
//              en el hemisferio X+.
//
// La siguiente macro permite modificar algunas caracteristicas.
// #macro EDEP_EmpujeDobleExhibicionPublica(
//               FraccionDerecho, FraccionIzquierdo,
//               AltoFundamental, AltoEjeSuperior, AltoEjeInferior,
//               LargoEjeSuperior, LargoSilla, DiametroSoporte,
//               DiametroSecundario, SeparacionEjeSilla,
//               SeparacionBrazos, LargoSuperiorBrazo,
//               TexturaPrincipal, TexturaSoporte,
//               TexturaDinamica, TexturaSujetador,
//               TexturaDecorativa, TexturaMango )
//      FraccionDerecho         : Fraccion propia de empuje para las barras
//              en el hemisferio X-.
//      FraccionIzquierdo       : Fraccion propia de empuje para las barras
//              en el hemisferio X+.  
//      AltoFundamental         : Alto del aparato. Valor por defecto 1425*L.
//      AltoEjeSuperior         : Altura desde el suelo para la barra divisoria
//              superior. Valor por defecto 1200*L.
//      AltoEjeInferior         : Altura desde el suelo para la barra divisoria
//              inferior. Valor por defecto 370*L.
//      LargoEjeSuperior        : Referencia para el largo de la barra divisoria
//              superior. Valor por defecto 380*L.
//      LargoSilla              : Referencia para el largo X de la silla.
//              Valor por defecto 225*L.
//      DiametroSoporte         : Diametro de las barras principales que soportan la maquina.
//              Valor por defecto 100*L.
//      DiametroSecundario      : Diametro para tubos accesorios a las barras soporte.
//              Valor por defecto 42*L.
//      SeparacionEjeSilla      : Medida de la separacion entre las sillas y el eje central.
//              Valor por defecto 300*L.
//      SeparacionBrazos        : Separacion Z de los brazos de la maquina.
//              Valor por defecto 560*L.
//      LargoSuperiorBrazo      : Referencia para el largo de los brazos.
//              Valor por defecto 325*L.
//      TexturaPrincipal        : Textura principal a aplicar en la estructura.
//              Valor por defecto EDEP_TexturaPrincipal.
//      TexturaSoporte          : Textura de la base inferior.
//              Valor por defecto EDEP_TexturaSoporte.
//      TexturaDinamica         : Textura del empuje doble propiamente.
//              Valor por defecto EDEP_TexturaDinamica.
//      TexturaSujetador        : Textura de los aros metalicos para sujetar
//              el empuje doble a la estructura.  Valor por defecto EDEP_TexturaSujetador.
//      TexturaDecorativa       : Textura para decoracion de los extremos del soporte.
//              Valor por defecto EDEP_TexturaDecorativa.  
//      TexturaMango            : Textura para el mango del empuje doble.
//              Valor por defecto EDEP_TexturaMango.
//      
// La mquina de empuje doble con parametros nulos se encuentra completamente contenida
// entre las siguientes coordenadas.
//      Minimo  = < -725,    0, -300 >*L
//      Maximo  = <  725, 1440,  300 >*L  
// Los asientos miran hacia ambos sentidos del eje X, gravedad Y-. 
// El cilindro central alineado con el origen del plano XZ.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare EDEP_DefaultTexturaPrincipal        
//      Textura principal a aplicar en la estructura.
// #declare EDEP_DefaultTexturaSoporte          
//      Textura de la base inferior.
// #declare EDEP_DefaultTexturaDinamica         
//      Textura del empuje doble propiamente.
// #declare EDEP_DefaultTexturaSujetador        
//      Textura de los aros metalicos para sujetar
//      el empuje doble a la estructura.  
// #declare EDEP_DefaultTexturaDecorativa       
//      Textura para decoracion de los extremos del soporte.  
// #declare EDEP_DefaultTexturaMango
//      Textura para el mango del empuje doble.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare EDEP_TexturaPrincipal                   = texture { ... }        
//      Textura principal a aplicar en la estructura.
// #declare EDEP_TexturaSoporte                     = texture { ... }
//      Textura de la base inferior.
// #declare EDEP_TexturaDinamica                    = texture { ... }         
//      Textura del empuje doble propiamente.
// #declare EDEP_TexturaSujetador                   = texture { ... }
//      Textura de los aros metalicos para sujetar 
//      el empuje doble a la estructura.  
// #declare EDEP_TexturaDecorativa                  = texture { ... }
//      Textura para decoracion de los extremos del soporte.     
// #declare EDEP_TexturaMango                       = texture { ... }
//      Textura para el mango del empuje doble.
//        
// Para colocarlo simplemente
// #include "EDEP.inc" 
// object { EDEP_EmpujeDoble(0,0)
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "EDEP.inc"   
// object                       {
//   EDEP_EmpujeDobleExhibicionPublica( 0, 0,
//              1.425, 1.200, 0.370, 0.380, 0.225, 0.100, 0.042, 0.300, 0.560, 0.325, 
//              EDEP_TexturaPrincipal, EDEP_TexturaSoporte, EDEP_TexturaDinamica, 
//              EDEP_TexturaSujetador, EDEP_TexturaDecorativa, EDEP_TexturaMango )
// }
//        
// Con modificadores
// #include "EDEP.inc"
// #include "textures.inc"
// #declare EDEP_TexturaPrincipal   = PinkAlabaster
// object        { EDEP_EmpujeDoble(0,0) }
//
#if ( version >= 3.7 )
  #version 3.7; 
#end

global_settings { assumed_gamma 1.0 }

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}   

#include "EDEP.inc"

#local FactorAcercamiento       = 0.9;
                                   
object                                  {
  EDEP_EmpujeDoble( 1.0, 0.1 )
  translate             -0.70*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}

