// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 17 agosto 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// GPSM GrifoPlasticoSimulacionMetal
// El archivo dibuja un grifo para servicio de agua domestico
// un modelo muy popular en Costa Rica.
//
// La macro principal tiene solo un parametro. 
// #macro GPSM_Grifo( AnguloLlave ) 
//      AnguloLlave             : Angulo para girar la llave del grifo.
//
// La siguiente macro permite modificar las texturas.
// #macro GPSM_GrifoPlasticoSimulacionMetal( AnguloLlave,
//               MaterialGrifo, MaterialUnionInterna, MaterialBoquilla )
//      AnguloLlave             : Angulo para girar la llave del grifo.   
//      MaterialGrifo           : Material principal del aparato.
//              Valor por defecto GPMS_MaterialGrifo.   
//      MaterialUnionInterna    : Material interno y poco visible 
//              en la union del grifo a la tuberia. 
//              Valor por defecto GPSM_MaterialUnionInterno.
//      MaterialBoquilla        : Material interno en la boca del grifo.
//              Valor por defecto GPSM_MaterialBoquilla.
//                                                                       
// El grifo con angulo nulo se encuentra completamente contenido 
// entre las siguientes coordenada.
//      Minimo  = <  -18,  -37,  -18 >*L
//      Maximo  = <  103,   81,   18 >*L 
// El grifo mira hacia X+, gravedad Y-. La rosca de unin con la tubera de la casa
// parte centrada desde el origen de coordenadas. 
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare GPSM_DefaultMaterialGrifo       
//      Material principal del aparato.
// #declare GPSM_DefaultMaterialUnionInterna          
//      Material interno y poco visible en la union del grifo y la tuberia.
// #declare GPSM_DefaultMaterialBoquilla       
//      Material interno en la boca del grifo.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare GPSM_MaterialGrifo                      = material { ... }        
//      Material principal del aparato.
// #declare GPSM_MaterialUnionInterna               = material { ... }
//      Material interno y poco visible en la union del grifo y la tuberia.
// #declare GPSM_MaterialBoquilla                   = material { ... }         
//      Material interno en la boca del grifo.
//        
// Para colocarlo simplemente
// #include "GPSM.inc" 
// object { GPSM_Grifo(0) }
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "GPSM.inc"   
// object                       {
//   GPSM_GrifoPlasticoSimulacionMetal( 0, 
//          GPSM_MaterialGrifo, GPSM_MaterialUnionInterna, GPSM_MaterialBoquilla )
// }
//        
// Con modificadores
// #include "GPSM.inc"
// #include "textures.inc"
// #declare GPSM_MaterialPrincipal   = material {  texture { PinkAlabaster } }
// object        { GPSM_Grifo(0) }
//
#if ( version >= 3.7 )
  #version 3.7; 
#end

global_settings { assumed_gamma 1.0 }

#include "colors.inc"
     
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "GPSM.inc"

#declare FactorAcercamiento             = 10;

object                                  {
  GPSM_Grifo( 30 )              
  translate         -0.04*x-0.02*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z     
}
