// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 10 enero 2017
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//      
// R2X1 RelojDosPorUno
// El archivo dibuja un reloj de pulsera, el modelo real utilizado
// se vende con dos pulseras a escoger. 
// Es muy poco flexible pero incluye una macro para modificar
// texturas y unas pocas caracteristicas. Es compatible con POV-Ray 3.1.
//
// La macro principal tiene cinco parametros.   
// #macro R2X1_Reloj( AnguloHorario, AnguloMinutero, AnguloSegundero,
//                BanderaPulsera, BanderaPerilla )
//      AnguloHorario           : Angulo en grados para rotar el horario.
//      AnguloMinutero          : Angulo en grados para rotar el minutero.
//      AnguloSegundero         : Angulo en grados para rotar el segundero. 
//      BanderaPulsera          : "on" dibuja el soporte para pulsera, "off"
//            no lo dibuja.
//      BanderaPerilla          : "on" dibuja la perilla de calibracion,
//            "off" no la dibuja.
//
// La siguiente macro permite mayor control de las caracteristicas.
// #macro R2X1_Reloj2X1( AnguloHorario, AnguloMinutero, AnguloSegundero,
//                BanderaPulsera, BanderaPerilla, DiametroReloj,
//                DiametroCristal, GruesoReloj, ProfundidadCaratula,
//                AnchoBanda, SeparacionBanda, GruesoMetal, AnchoPerilla,
//                MaterialPrincipal, MaterialCristal, MaterialMetal,
//                MaterialPerilla, MaterialFosforescente, MaterialSegundero )
//      AnguloHorario           : Angulo en grados para rotar el horario.
//      AnguloMinutero          : Angulo en grados para rotar el minutero.
//      AnguloSegundero         : Angulo en grados para rotar el segundero.
//      BanderaPulsera          : "on" dibuja el soporte para pulsera, "off"
//            no lo dibuja.
//      BanderaPerilla          : "on" dibuja la perilla de calibracion,
//            "off" no la dibuja. 
//      DiametroReloj           : Diametro fundamental del reloj.
//            Valor por defecto 27.2*L.
//      DiametroCristal         : Diametro del vidrio protector del reloj. 
//            Valor por defecto 23.6*L.
//      GruesoReloj             : Grueso fundamental de reloj.  
//            Valor por defecto 6.4*L.
//      ProfundidadCaratula     : Espacio desde el vidrio a la caratula impresa.
//            Valor por defecto 1.0*L.
//      AnchoBanda              : Ancho de la pulsera a utilizar.
//            Valor por defecto 14.1*L.
//      SeparacionBanda         : Separacion de los extremos del soporte de 
//            pulsera. Valor por defecto 34.5*L.
//      GruesoMetal             : Grueso de las laminillas metalicas.
//            Valor por defecto 0.5*L.
//      AnchoPerilla            : Grosor a lo largo del cilindro de calibracion.
//            Valor por defecto 1.7*L.      
//      MaterialPrincipal       : Material principal a aplicar al objeto.
//            Valor por defecto R2X1_MaterialPrincipal. 
//      MaterialCristal         : Material para la cubierta protectora.
//            Valor por defecto R2X1_MaterialCristal.
//      MaterialMetal           : Material para aplicar a zonas metalicas.
//            Valor por defecto R2X1_MaterialMetal.
//      MaterialPerilla         : Material para la perilla de calibracion.
//            Valor por defecto R2X1_MaterialPerilla.
//      MaterialFosforescente   : Material fosforescente sobre parte del
//            horario y minutero. Valor por defecto R2X1_MaterialFosforescente.
//      MaterialSegundero       : Material a aplicar al segundero.
//            Valor por defecto R2X1_MaterialSegundero .
//      
// La reloj con sus valores por defecto se encuentra completamente contenido en:   
//      Punto Minimo    = < -13.6, -17.3,  -6.4 >*L
//      Punto Maximo    = < +15.7, +17.3,  +1.0 >*L 
// El reloj mira con el frente hacia Z- gravedad Y-. El eje de giro de las
// agujas se encuentra en el centro de coordenadas XY. Excepto por el soporte
// de pulsera, la base del reloj descansa sobre el plano XY hacia Z-. 
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare R2X1_DefaultMaterialPrincipal       
//      Material principal a aplicar al objeto.
// #declare R2X1_DefaultMaterialCristal          
//      Material para la cubierta protectora.
// #declare R2X1_DefaultMaterialMetal           
//      Material para aplicar a zonas metalicas.
// #declare R2X1_DefaultMaterialPerilla         
//      Material para la perilla de calibracion.
// #declare R2X1_DefaultMaterialFosforescente   
//      Material fosforescente sobre parte del horario y minutero. 
// #declare R2X1_DefaultMaterialSegundero       
//      Material a aplicar al segundero.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare R2X1_GIFCaratula               = "R2X1_IM1.gif"  
//      Imagen GIF impresa en la caratula para leer la hora.  
// #declare R2X1_BanderaColorTransparente  = off;
//      "on" indica que algun indice GIF es transparente. "off" no aplica.  
// #declare R2X1_GIFIndiceTransparente     = 0;
//      Valor indice del color transparente GIF si aplica.
// #declare R2X1_NormalCaratula            = normal { bumps }
//      Agrega variacion normal al mapa GIF de la caratula.
// #declare R2X1_FinishCaratula            = finish { }  
//      Agrega finish al mapa GIF de la caratula.
// #declare R2X1_TexturaCaratulaExtra      = texture { pigment { rgbf 1 } }
//      Permite sobreponer una textura adicional en capa sobre
//      la caratula. Util para envejecimiento y efectos similares.
// #declare R2X1_MaterialPrincipal         =
//                  material { R2X1_DefaultMaterialPrincipal }
//      Material principal a aplicar al objeto.
// #declare R2X1_MaterialCristal           =
//                  material { R2X1_DefaultMaterialCristal }
//      Material para la cubierta protectora.
// #declare R2X1_MaterialMetal             =
//                  material { R2X1_DefaultMaterialMetal }
//      Material para aplicar a zonas metalicas.
// #declare R2X1_MaterialPerilla           =
//                  material { R2X1_DefaultMaterialPerilla } 
//      Material para la perilla de calibracion.
// #declare R2X1_MaterialFosforescente     =
//                  material { R2X1_DefaultMaterialFosforescente } 
//      Material fosforescente sobre parte del horario y minutero. 
// #declare R2X1_MaterialSegundero         =
//                  material { R2X1_DefaultMaterialSegundero } 
//      Material a aplicar al segundero.
//        
// Para colocarlo simplemente
// #include "R2X1.inc" 
// object { R2X1_Reloj( 10, 100, 200, on, on ) }
//                                 
// Ejemplo con la macro detallada, mismo objeto default
// #include "R2X1.inc"   
// object                       {
//   R2X1_Reloj2X1( 10, 100, 200, on, on,
//            0.0272, 0.0236, 0.0064, 0.0010, 0.0141, 
//            0.0345, 0.0005, 0.0017,
//            R2X1_MaterialPrincipal, R2X1_MaterialCristal,
//            R2X1_MaterialMetal, R2X1_MaterialPerilla,
//            R2X1_MaterialFosforescente, R2X1_MaterialSegundero )
// }
//        
// Con modificadores
// #include "R2X1.inc"
// #include "textures.inc"
// #declare R2X1_MaterialPrincipal   = material { textures { PinkAlabaster } }
// object        { R2X1_Reloj( 10, 100, 200, on, on ) }
//
#if ( version >= 3.7 )
  #version 3.7; 
#end

global_settings { assumed_gamma 1.0 }

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;

camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}

light_source    {
         < 500  , 500   , -3000 >*L
         White
}


background      {
         Gray50
}    


#include "R2X1.inc"

#local FactorAcercamiento       = 35;                                   
                                   
object                                  {
  R2X1_Reloj( 10, 80, 190, on, on )
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}
