// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 13 julio 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// SCPA SierraCortanteParaAdultos
// El archivo dibuja una sierra de mano para uso domstico.
// Es muy poco flexible. Es compatible con POVRay 3.1.
//
// La macro principal no tiene parametros. 
// #macro SCPA_Sierra( ) 
//                                               
// La siguiente macro permite mayor flexibilidad de las caracteristicas.
// #macro SCPA_SierraCortanteParaAdultos( LargoBase, AltoBase, GruesoBase,
//                  LargoAdicional, AltoSierra, GruesoSierra, LargoMango,
//                  MaterialPrincipal, MaterialFilo,
//                  MaterialAgarre, MaterialTornillo, MaterialMango )
//      LargoBase               : Largo referencia X para el cuerpo principal de la sierra.
//              Valor por defecto 138.0*L.
//      AltoBase                : Alto referencia Y para el soporte principal del aparato.
//              Valor por defecto 19.5*L.
//      GruesoBase              : Grueso referencia Z para el soporte de la sierra.
//              Valor por defecto 7.5*L.
//      LargoAdicional          : Largo extra para el dibujo de la sierra completa.
//              Valor por defecto 125.0*L.
//      AltoSierra              : Alto extra para ubicar la sierra.
//              Valor por defecto 50.0*L.
//      GruesoSierra            : Grueso referencia Z para la sierra. Valor por defecto 0.5*L.
//      LargoMango              : Largo del mango para el cuerpo de la sierra.
//              Valor por defecto 32.0*L.
//      MaterialPrincipal       : Material principal para el aparato. 
//              Valor por defecto SCPA_MaterialPrincipal.
//      MaterialFilo            : Material del filo de la sierra.
//              Valor por defecto SCPA_MaterialFilo.
//      MaterialAgarre          : Material para el soporte metalico del aparato.
//              Valor por defecto SCPA_MaterialAgarre.
//      MaterialTornillo        : Material para los tornillos.
//              Valor por defecto SCPA_MaterialTornillo.
//      MaterialMango           : Material para el mango de la sierra.
//              Valor por defecto SCPA_MaterialMango.
//      
// La sierra se encuentra completamente contenida dentro de las siguientes coordenadas.
//      Minimo  = < -54, -68,  -8 >*L
//      Maximo  = < 265,   1,   8 >*L  
// Frente mira hacia X+, gravedad Y-. El origen se ubica casi en el borde superior
// de la unin entre el mango y la sierra.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare SCPA_DefaultMaterialPrincipal  
//      Material principal para el aparato.
// #declare SCPA_DefaultMaterialFilo      
//      Material del filo de la sierra.
// #declare SCPA_DefaultMaterialAgarre
//      Material para el soporte metalico del aparato.
// #declare SCPA_DefaultMaterialTornillo
//      Material para los tornillos.
// #declare SCPA_DefaultMaterialMango
//      Material para el mango de la sierra.           
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare SCPA_MaterialPrincipal              = material { ... }                 
//      Material principal para el aparato.
// #declare SCPA_MaterialFilo                   = material { ... }
//      Material del filo de la sierra.                                   
// #declare SCPA_MaterialAgarre                 = material { ... }
//      Material para el soporte metalico del aparato.
// #declare SCPA_MaterialTornillo               = material { ... }
//      Material para los tornillos.
// #declare SCPA_MaterialMango                  = material { ... }
//      Material para el mango de la sierra.
//        
// Para colocarlo simplemente
// #include "SCPA.inc" 
// object { SCPA_Sierra( ) }
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "SCPA.inc"   
// object                       {
//   SCPA_SierraCortanteParaAdultos(0.138,0.0195,0.0075,0.125,0.050,0.0005,0.032,
//      SCPA_MaterialPrincipal, SCPA_MaterialFilo,
//      SCPA_MaterialAgarre, SCPA_MaterialTornillo, SCPA_MaterialMango)
// }
//        
// Con modificadores
// #include "SCPA.inc"
// #include "textures.inc"
// #declare SCPA_MaterialPrincipal   = material { texture { PinkAlabaster } }
// object        { SCPA_Sierra( ) }
// 
#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "SCPA.inc"

#local FactorAcercamiento       = 6;                                   
                                   
object                                  {
  SCPA_Sierra( )            
  translate       -0.105*x+0.030*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}
